----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:10:16 10/29/2008 
-- Design Name: 
-- Module Name:    Binary_Reg2 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Binary_Reg2 is
    Port ( Clk : 						 in   STD_LOGIC;
	        Modin: 					 in   STD_LOGIC;	
			  Modout:  					 out  STD_LOGIC;			  
           Hex3,Hex2,Hex1,Hex0 : out  STD_LOGIC_VECTOR (3 downto 0);
           Strobe : 					 out  STD_LOGIC);
end Binary_Reg2;

architecture Behavioral of Binary_Reg2 is
	signal Counter: STD_LOGIC_VECTOR (4 downto 0) := "00000";
	signal Strobe_puls: STD_LOGIC;
	signal Binreg:  STD_LOGIC_VECTOR (15 downto 0);
begin

	Strobe <= Strobe_puls;
	Modout <= Binreg(15);
	Hex3   <= Binreg(15 downto 12);
	Hex2   <= Binreg(11 downto  8);
	Hex1   <= Binreg( 7 downto  4);
	Hex0   <= Binreg( 3 downto  0);
	
	--Strobe_puls <= '0' when Counter<10 else '1';
	
	-----------------------------------------------------------
	-- This process will generate the Strobe puls after
	-- the 12 clock pulses which used for the conversion
	-----------------------------------------------------------
	process( Clk)
	begin
		if rising_edge( Clk) then
			if Counter<=9 then  
				Counter <= Counter+1;
			 	Strobe_puls <= '0';
			else
				Counter <= (others=>'0');
			 	Strobe_puls <= '1';
			end if;	
		end if;
	end process;
	
	-----------------------------------------------------------
	-- This process controls the Binreg and hence it loads the
	-- Binreg with the next binary value and shift the same
	-- value leftmost in order to convert
	-----------------------------------------------------------
	process( Clk)
	begin
		if rising_edge( Clk) then
			if Strobe_puls='1' then
				Binreg <= (others=>'0');
			else
				Binreg <= Binreg(14 downto 0)&Modin;
			end if;
		end if;
	end process;
end Behavioral;

